package com.jasamedika.medifirst2000.service.impl;

import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.orm.jpa.JpaSystemException;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.jasamedika.medifirst2000.converter.BaseConverterImpl;
import com.jasamedika.medifirst2000.converter.GenericViewConverter;
import com.jasamedika.medifirst2000.converter.PapRiwayatPsikososialConverter;
import com.jasamedika.medifirst2000.converter.PapStatusPsikososialConverter;
import com.jasamedika.medifirst2000.converter.PapTempatTinggalConverter;
import com.jasamedika.medifirst2000.dao.PapRiwayatPsikososialDao;
import com.jasamedika.medifirst2000.dao.PapStatusMentalDao;
import com.jasamedika.medifirst2000.dao.PapStatusPsikososialDao;
import com.jasamedika.medifirst2000.dao.PapTempatTinggalDao;
import com.jasamedika.medifirst2000.dao.PasienDao;
import com.jasamedika.medifirst2000.dao.RegistrasiPelayananPasienDao;
import com.jasamedika.medifirst2000.entities.GenericView;
import com.jasamedika.medifirst2000.entities.PapKeluhanTambahan;
import com.jasamedika.medifirst2000.entities.PapRiwayatPsikososial;
import com.jasamedika.medifirst2000.entities.PapSkriningGiziDetail;
import com.jasamedika.medifirst2000.entities.PapStatusMental;
import com.jasamedika.medifirst2000.entities.PapStatusPsikososial;
import com.jasamedika.medifirst2000.entities.PapTempatTinggal;
import com.jasamedika.medifirst2000.entities.Pasien;
import com.jasamedika.medifirst2000.entities.PengkajianAwalBaru;
import com.jasamedika.medifirst2000.entities.RegistrasiPelayananPasien;
import com.jasamedika.medifirst2000.exception.ServiceVOException;
import com.jasamedika.medifirst2000.service.PapRiwayatPsikososialService;
import com.jasamedika.medifirst2000.util.CommonUtil;
import com.jasamedika.medifirst2000.vo.GenericViewVO;
import com.jasamedika.medifirst2000.vo.PapKeluhanTambahanVO;
import com.jasamedika.medifirst2000.vo.PapRiwayatPsikososialVO;
import com.jasamedika.medifirst2000.vo.PapSkriningGiziDetailVO;
import com.jasamedika.medifirst2000.vo.PapStatusMentalVO;
import com.jasamedika.medifirst2000.vo.PapStatusPsikososialVO;
import com.jasamedika.medifirst2000.vo.PapTempatTinggalVO;
import com.jasamedika.medifirst2000.vo.PengkajianAwalBaruVO;

/**
 * Implement class for PAPRiwayatPsikososialService
 * 
 * @author Askur
 */
@Service("PAPRiwayatPsikososialService")
public class PapRiwayatPsikososialServiceImpl implements PapRiwayatPsikososialService {
	@Autowired
	private PapRiwayatPsikososialDao papRiwayatPsikososialDao;
	@Autowired
	private PapStatusPsikososialDao papStatusPsikososialDao;
	
	@Autowired
	private PapTempatTinggalDao papTempatTinggalDao;
	@Autowired
	private PapStatusMentalDao papStatusMentalDao;
	@Autowired
	private PapRiwayatPsikososialConverter papRiwayatPsikososialConverter;
	@Autowired
	private PapStatusPsikososialConverter papStatusPsikososialConverter;
	@Autowired
	private PapTempatTinggalConverter papTempatTinggalConverter;
	@Autowired
	private GenericViewConverter genericViewConverter;
	@Autowired
	private RegistrasiPelayananPasienDao registrasiPelayananPasienDao;
	@Autowired
	private BaseConverterImpl<PapStatusMentalVO,PapStatusMental> papStatusMentalConverter;
	@Autowired
	private PasienDao pasienDao;
	@Autowired
	private BaseConverterImpl<PengkajianAwalBaruVO, PengkajianAwalBaru> pengkajianAwalBaruConverter;
	
	@Override
	@Transactional(readOnly=false)
	public Map<String,Object> addRiwayatPsikososial(PapRiwayatPsikososialVO vo) throws JpaSystemException, ServiceVOException {
		Map<String,Object> result=new HashMap<String,Object>();
		PapRiwayatPsikososial model=papRiwayatPsikososialConverter.transferVOToModel(vo, new PapRiwayatPsikososial());
		model.setNoRec(vo.getNoRec());
		
		if(CommonUtil.isNotNullOrEmpty(vo.getPengkajianAwalBaru())){
			model.setPengkajianAwalBaru(pengkajianAwalBaruConverter.transferVOToModel(vo.getPengkajianAwalBaru(), new PengkajianAwalBaru()));
		}
		
		List<PapStatusMental> listMental = papStatusMentalDao.findByPapStatusMental(model.getNoRec());
		for (PapStatusMental papStatusMental : listMental) {
			papStatusMentalDao.delete(papStatusMental);
		}

		List<PapStatusPsikososial> list = papStatusPsikososialDao.findByRiwayatPsikososial(model.getNoRec());
		for (PapStatusPsikososial papStatusPsikososial : list) {
			papStatusPsikososialDao.delete(papStatusPsikososial);
		}
		
		List<PapTempatTinggal> listTempatTidur = papTempatTinggalDao.findByRiwayatPsikososial(model.getNoRec());
		for (PapTempatTinggal papStatusPsikososial : listTempatTidur) {
			papTempatTinggalDao.delete(papStatusPsikososial);
		}
		List<PapStatusPsikososial> detailStatusPsikososial=new ArrayList<PapStatusPsikososial>();
		
		List<PapTempatTinggal> detailTempatTinggal=new ArrayList<PapTempatTinggal>();
		model.getPapStatusMentalSet().clear();
		model.getPapStatusPsikososialSet().clear();
		model.getPapTempatTinggalSet().clear();
		PapRiwayatPsikososial resultModel=papRiwayatPsikososialDao.save(model);
		
		for(PapStatusMentalVO voDetail:vo.getPapStatusMentalSet()){
			PapStatusMental modelDetail=papStatusMentalConverter.transferVOToModel(voDetail, new PapStatusMental());
			modelDetail.setPapRiwayatPsikososial(resultModel);
			papStatusMentalDao.save(modelDetail);
		}
		for(PapStatusPsikososialVO voDetail:vo.getPapStatusPsikososialSet()){
			PapStatusPsikososial modelDetail=papStatusPsikososialConverter.transferVOToModel(voDetail, new PapStatusPsikososial());
			modelDetail.setPapRiwayatPsikososial(resultModel);
			papStatusPsikososialDao.save(modelDetail);
		}
		for(PapTempatTinggalVO voDetail:vo.getPapTempatTinggalSet()){
			PapTempatTinggal modelDetail=papTempatTinggalConverter.transferVOToModel(voDetail, new PapTempatTinggal());
			modelDetail.setPapRiwayatPsikososial(resultModel);
			papTempatTinggalDao.save(modelDetail);
		}
		if(CommonUtil.isNotNullOrEmpty(resultModel)){
			result.put("noRec", resultModel.getNoRec());
		}
		return result;
	}

	@Override
	public Map<String,Object> updateRiwayatPsikososial(PapRiwayatPsikososialVO vo) throws JpaSystemException, ServiceVOException {
		Map<String,Object> result=new HashMap<String,Object>();
		PapRiwayatPsikososial model=papRiwayatPsikososialConverter.transferVOToModel(vo, new PapRiwayatPsikososial());
		List<PapStatusPsikososial> detailStatusPsikososial=new ArrayList<PapStatusPsikososial>();
		for(PapStatusPsikososialVO voDetail:vo.getPapStatusPsikososialSet()){
			PapStatusPsikososial modelDetail=papStatusPsikososialConverter.transferVOToModel(voDetail, new PapStatusPsikososial());
			modelDetail.setPapRiwayatPsikososial(model);
			detailStatusPsikososial.add(modelDetail);
		}
		model.getPapStatusPsikososialSet().clear();
		model.getPapStatusPsikososialSet().addAll(detailStatusPsikososial);
		List<PapTempatTinggal> detailTempatTinggal=new ArrayList<PapTempatTinggal>();
		for(PapTempatTinggalVO voDetail:vo.getPapTempatTinggalSet()){
			PapTempatTinggal modelDetail=papTempatTinggalConverter.transferVOToModel(voDetail, new PapTempatTinggal());
			modelDetail.setPapRiwayatPsikososial(model);
			detailTempatTinggal.add(modelDetail);
		}
		model.getPapTempatTinggalSet().clear();
		model.getPapTempatTinggalSet().addAll(detailTempatTinggal);
		PapRiwayatPsikososial resultModel=papRiwayatPsikososialDao.save(model);
		if(CommonUtil.isNotNullOrEmpty(resultModel)){
			result.put("papRiwayatPsikososial", resultModel);
		}
		return result;
	}

	@Override
	public List<PapRiwayatPsikososialVO> findAll() throws JpaSystemException {
		return null;
	}

	@Override
	public Map<String,Object> findByNoCmAndTglInput(String noCm, Date tglInput) {
		Map<String,Object> result=new HashMap<String,Object>();
		PapRiwayatPsikososial resultModel=papRiwayatPsikososialDao.findPapRiwayatPsikososialByNoCmAndTglInput(noCm, tglInput);
		if(CommonUtil.isNotNullOrEmpty(resultModel)){
			result.put("papRiwayatPsikososial", resultModel);
			result.put("dataFound", true);
		} else {
			result.put("dataFound", false);
		}
		return result;
	}

	@Override
	public Map<String,Object> findRegistrasiPelayananPasienByNoCmAndTglRegistrasi(String noCm, short kdProfile,Date tglRegistrasi) {
		Map<String,Object> result=new HashMap<String,Object>();
		RegistrasiPelayananPasien resultModel=registrasiPelayananPasienDao.finByNoCm(noCm,kdProfile,tglRegistrasi);
		if(CommonUtil.isNotNullOrEmpty(resultModel)){
			result.put("noRec", resultModel.getNoRec());
			result.put("tglRegistrasi", resultModel.getTglMasuk());
			result.put("noAntrian", resultModel.getNoAntrian());
			result.put("dataFound", true);
			if(CommonUtil.isNotNullOrEmpty(resultModel.getPasien().getId())){
				result.put("pasien.noCm", resultModel.getPasien().getNoCm());
			}
		}else{
			result.put("dataFound", false);
		}
		return result;
	}

	@Override
	public Map<String,Object> findPasienByNoCm(String noCm) {
		Map<String,Object> result=new HashMap<String,Object>();
		List<Pasien> resultModel=pasienDao.findPasienBynoCm(noCm);
		if(CommonUtil.isNotNullOrEmpty(resultModel)){
			for(Pasien pasien:resultModel){
				result.put("noCm", pasien.getNoCm());
				result.put("namaPasien", pasien.getNamaPasien());
				if(CommonUtil.isNotNullOrEmpty((pasien.getAlamats().iterator().next()))){
				result.put("alamatLengkap", (pasien.getAlamats().iterator().next()).getAlamatLengkap());
				}
				if(CommonUtil.isNotNullOrEmpty(pasien.getJenisKelamin())){
				result.put("jenisKelamin", pasien.getJenisKelamin().getNamaExternal());
				}
				if(CommonUtil.isNotNullOrEmpty(pasien.getStatusPerkawinan())){
				result.put("statusPerkawinan", pasien.getStatusPerkawinan().getNamaExternal());
				}
				result.put("dataFound", true);
			}
		}else{
			result.put("dataFound", false);
		}
		return result;
	}

	@Override
	public Object add(Object vo) throws JpaSystemException, ServiceVOException {
		return null;
	}

	@Override
	public Object update(Object vo) throws JpaSystemException, ServiceVOException {
		return null;
	}

	@Override
	public Boolean delete(Object key) throws JpaSystemException {
		return null;
	}

	@Override
	public Object findById(Object key) throws JpaSystemException {
		return null;
	}

	@Override
	public Map findAllWithPageAndLimitAndSortByAndDirectionParameter(Integer page, Integer limit, String sort,
			String dir) {
		return null;
	}


}
